package strangepatterns2.courier;

import javax.swing.*;
import java.awt.event.ActionEvent;

import strangepatterns2.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class Courier
    extends AbstractAction {


  public Courier(Producer p, Consumer c) {
    putValue("PRODUCER", p);
    putValue("CONSUMER", c);
    putValue(Action.NAME, "browse");
  }

  public void actionPerformed(ActionEvent actionEvent) {
    execute();
  }

  protected void execute() {
    Producer prod = (Producer) getValue("PRODUCER");
    Consumer cons = (Consumer) getValue("CONSUMER");
    Object message = null;
    if (prod != null) {
      message = prod.produce();
    }
    if (cons != null) {
      cons.consume(message);
    }
  }

} //END